(function(){

	/* cssession id created after successful login. */
	ingrs.auth.cssessionid = null;

	/* clientId of the participant after successful login. */
	ingrs.auth.selectedClient = null;
	
	/* contact no of client */
	ingrs.auth.clientInformationLine = null;

	/* Client timeout in Mins */
	ingrs.auth.timeoutInMin = 15;
	
	/* records time when user pauses the app*/
	ingrs.auth.pauseTime = null;
	
	ingrs.auth.createLoginWindow = function() {
		var navGroup,prefWindow;
			 var scrollView = Titanium.UI.createScrollView({
		    contentWidth:'auto',
		    contentHeight:'auto',
		    top:0,
		    showVerticalScrollIndicator:true,
		    showHorizontalScrollIndicator:true,
		    layout:'vertical'
		});
		
		if(ingrs.isIphone()) {

		var loginWindow= Ti.UI.createWindow({
				navBarHidden:true
			});

			var modalWin= Ti.UI.createWindow({
				title:L('Label_Back_Button'),
				backgroundColor:'#E7E7E7',
				exitOnClose : true,
				navBarHidden: true,
				gaActivity : 'Login'
			});

			navGroup = Ti.UI.iPhone.createNavigationGroup({
				window:modalWin
			});
			
			modalWin.add(scrollView);
			//loginWindow.add(navGroup);
		} else if(ingrs.isAndroid()) {
		var loginWindow = Ti.UI.createWindow({
				  title:'Login',
				  exitOnClose : true,
		  		  backgroundColor:'#E7E7E7',
		  		  gaActivity : 'Login'
			});
				loginWindow.add(scrollView);
		} else {
			var mainWin = Ti.UI.createWindow({backgroundColor:'#FFFFFF'});
			mainWin.gaActivity = 'Login Main Win';
			ingrs.ga.wrapWindowWithGA(mainWin);
			var loginWindow= Ti.UI.createWindow({
				navBarHidden:true
			});
			loginWindow.gaActivity = 'Login Nav Win';
			ingrs.ga.wrapWindowWithGA(loginWindow);
			navGroup = Ti.UI.MobileWeb.createNavigationGroup({
				window:loginWindow
			});
			mainWin.add(navGroup);
		}
	
		/* label ends*/
		var loginHeader = ingrs.auth.ui.createLoginHeader();
		
		loginHeader.addEventListener('click',function(){
			ingrs.auth.blurFields();
		});
		
		scrollView.add(loginHeader);
		
		/* preference starts */
		
			/* create table view */
			var loginPrefView = ingrs.auth.ui.createCustomTableView({top:15,height:132});
			
			var prefRow = ingrs.auth.ui.createCustomRowView({_showEndLine:true});
			
			var prefRowL1 = ingrs.auth.ui.createLabel({left:'3.1%',text:L('Login_Title'),color:'#363636'});
			
			var prefRowL2 = ingrs.auth.ui.createPrefLabel('Username');
			
			prefRowL2.serverId = 'UNAME';
			
			var prefArrow = Ti.UI.createView({
				width:9,
				height:13,
				backgroundImage:'/images/arrows/arrow_table_cell.png',
				anchorPoint:{y:0.5},
				right:'4%'
			});
			
			prefRow.add(prefRowL1);
			prefRow.add(prefRowL2);
			prefRow.add(prefArrow);
			
			prefRow.addEventListener('click',function(){
				userTypeValue.blur();
				passwdValue.blur();
				/* to update pref values when its changed */
				function updatePref(param){
					prefRowL2.text = param.loginDisplay;
					userTypeValue.hintText = param.loginDisplay;
					userTypeValue.keyboardType = param.keyboard;
					prefRowL2.serverId = param.serverValue;
					userTypeValue.passwordMask = param.mask;
					userTypeValue.value='';
					//userTypeMask.text = '';
					passwdValue.value='';
					/* removing the toolbar if the login type is Username */
					if(param.loginDisplay === 'Username'){
						userTypeValue.keyboardToolbar = null;
						userTypeValue.keyboardToolbarColor = null;
						userTypeValue.keyboardToolbarHeight = null;
					}else{
						userTypeValue.keyboardToolbar = param.keyboardToolbar;
						userTypeValue.keyboardToolbarColor = param.keyboardToolbarColor;
						userTypeValue.keyboardToolbarHeight = param.keyboardToolbarHeight;
						
					}
					if (prefRowL2.serverId==='SSN') {
						if(ingrs.isAndroid()) {
							rememberSwitch.value = false;
						}else{
							rememberSwitch.value = 0;
						}
						rememberSwitch.enabled = false;
					} else {
						rememberSwitch.enabled = true;
					}
				}
				
				if(ingrs.isAndroid()){
					ingrs.auth.loginPref.createWindow({'currentPref':prefRowL2.text,'updatePref':updatePref}).open();
				} else {
					
					//fn to close nav group from the login pref window
					function closePrefWindow(){
						navGroup.close(prefWindow);
					};
					
					/*On iOS Navigation group is specifically used to get the Back Button with 'Bezel Border'*/
					prefWindow=ingrs.auth.loginPref.createWindow({'currentPref':prefRowL2.text,'updatePref':updatePref,
						'closePrefWinFn':closePrefWindow});
					navGroup.open(prefWindow, {
						animated:true
					});
				}
				
			});
			ingrs.auth.ui.done.addEventListener('click',function(e){
				userTypeValue.blur();
			});
			
			
			loginPrefView.add(prefRow);
		
		/* preference ends */
		
		/* ssn / passwd starts */
		
		
			/* ssn starts */
			var userTypeRow = ingrs.auth.ui.createCustomRowView({_showEndLine:true});
			
			var userTypeValue = ingrs.auth.ui.createtextField({keyboard:Ti.UI.KEYBOARD_DEFAULT,password:true,hintText:'Username'});
			//var userTypeMask = ingrs.auth.ui.createMaskLabel();
			
			userTypeValue.addEventListener('return',function(){
				userTypeValue.blur();
			});
			/*userTypeValue.addEventListener('change',function(e) {
				Ti.API.info('User Id changed:'+e.source.value);
				if (prefRowL2.serverId==='SSN') return;
				
				var tmp = e.source.value;
				if (tmp.length>4) {
					tmp = tmp.substring(0,4);
				}
				userTypeMask.text = tmp;
			})*/;
			
			userTypeRow.add(userTypeValue);
			//userTypeRow.add(userTypeMask);
			
			userTypeRow.addEventListener('click',function(){
				userTypeValue.focus();
			});
			loginPrefView.add(userTypeRow);
		
			/* ssn ends */
			
			/* passwd starts */
			var passwdRow = ingrs.auth.ui.createCustomRowView({_showEndLine:false});
			
			var passwdValue = ingrs.auth.ui.createtextField({keyboard:Ti.UI.KEYBOARD_ASCII,password:true,hintText:'Password'});
			
			passwdValue.addEventListener('return',function(){
				passwdValue.blur();
			});
			
			passwdRow.add(passwdValue);
		
			loginPrefView.add(passwdRow);
			/* passwd ends */
		/* ssn / passwd ends */
			
		scrollView.add(loginPrefView);
		
		
		/* remember Id starts*/
		
		var rememberView = ingrs.auth.ui.createCustomTableView({top:19,height:44});
		
		var rememberRow =ingrs.auth.ui.createCustomRowView({_showEndLine:false});
			
			var rememberLabel = ingrs.auth.ui.createLabel({left:'3.1%',text:'Remember Me',color:'#363636'});
			
			var rememberSwitch = Ti.UI.createSwitch({
				style:ingrs.isAndroid()?Titanium.UI.Android.SWITCH_STYLE_CHECKBOX:'',
				right:'3.1%',
				height:44,
				value:true
			});
		
			rememberRow.add(rememberLabel);
			rememberRow.add(rememberSwitch);
		
			rememberView.add(rememberRow);
		scrollView.add(rememberView);
		/* remember ends starts*/
		loginWindow.resetWindow = resetLogin;
		
		 function resetLogin() {
			ingrs.auth.cssessionid = null;
			ingrs.auth.timeoutInMin = 15;
			passwdValue.value = '';
			userTypeValue.value = '';
			//userTypeMask.text = '';
			prefRowL2.text = 'Username';
			prefRowL2.serverId = 'UNAME';
			userTypeValue.hintText = 'Username';
			rememberSwitch.enabled = true;
			rememberSwitch.value = true;
			userTypeValue.keyboardToolbar = null;
			userTypeValue.keyboardToolbarColor = null;
			userTypeValue.keyboardToolbarHeight = null;
			userTypeValue.keyboardType = Ti.UI.KEYBOARD_DEFAULT;
			ingrs.auth.loginPref.populateSavedPref(prefRowL2,userTypeValue,rememberSwitch);
			focusField();				
		};
		//populate saved preferences
		ingrs.auth.loginPref.populateSavedPref(prefRowL2,userTypeValue,rememberSwitch);
		
		/* login button starts*/
		var loginBtn = ingrs.auth.ui.createLoginBtn();
		
		loginBtn.addEventListener('click',function(){
			ingrs.auth.blurFields();
			
			if(validateFields()){
				ingrs.auth.loginPref.storeLoginPref({isSavePref:rememberSwitch.value,loginType:prefRowL2.text,value:userTypeValue.value});
				var data = {
						participantId: userTypeValue.value,
						pin: passwdValue.value,
						useridtype:prefRowL2.serverId
					};
				
				passwdValue.value = '';
				if(prefRowL2.serverId === 'SSN'){
					userTypeValue.value = '';
				}
				ingrs.auth.authenticateUser({data:data});
			}
		});
		
		scrollView.add(loginBtn);
		
		/* login button ends*/
		
		scrollView.add(ingrs.auth.ui.createFooterlabel1());
		
		
		scrollView.add(ingrs.auth.ui.createFooterlabel2());
		
		
		loginWindow.add(scrollView);
		if(ingrs.isIphone()) {
			loginWindow.add(navGroup);
		}
		
		ingrs.auth.blurFields = function() {
			if (ingrs.isIphone()){
				userTypeValue.blur();
				passwdValue.blur();
			}
		};
		
		/* call that validates the user input*/
		function validateFields(){
			return ingrs.auth.validate.validateLoginInput({_loginType:prefRowL2.text,_userId:userTypeValue.value,_password:passwdValue.value});
		}
		
		loginWindow.addEventListener('open',function(){
			focusField();
		});
		
		function focusField(){
			if(rememberSwitch.value === true && (userTypeValue.value !== null && userTypeValue.value.trim() !== '') ){
				passwdValue.focus();
			}else{
				userTypeValue.focus();
			}
		}
		
		if(ingrs.isMobileWeb()){
			mainWin.resetWindow = resetLogin;
			return mainWin;
		} else {
			return loginWindow;
		}
		
	};
	
	/* method that is used to authenticate user*/
	ingrs.auth.authenticateUser = function(params){
		
		
		

		
	};
	
	ingrs.auth.checkForcedPages = function(_response) {
		var forcedPage = _response.forcePage;
		
		ingrs.log.debug('login() ::checkForcedPages:'+ingrs.auth.cssessionid + ' | '+forcedPage);
		
		if (forcedPage === 'mfa_challenge' || forcedPage === 'mfa_enrollment' || forcedPage === 'username_reset') {
			ingrs.log.debug('login() ::opening enhanced login window:'+ingrs.auth.cssessionid);
			ingrs.auth.createEnhancedLoginWindow({status:forcedPage}).open();
		}else if(forcedPage === 'change_password'){
			ingrs.log.debug('login() ::opening change Password window:'+ingrs.auth.cssessionid);
			ingrs.auth.createChangePwdWindow(_response).open();
		}else if(forcedPage === 'set_username' || forcedPage === 'reset_username'){
			ingrs.log.debug('login() ::opening setUsername window:'+ingrs.auth.cssessionid);
			ingrs.auth.createSetUsernameWindow(_response).open();
		}else if(forcedPage === 'sso_security'){
			ingrs.log.debug('login() ::opening setSecurity window:'+ingrs.auth.cssessionid);
			ingrs.auth.createSetSecurityWindow(_response).open();
		}else{
			var restrictedTrader = _response.restrictedTrader;
			//show error message for restricted traders and logout
			if(typeof restrictedTrader !== 'undefined' && restrictedTrader !== null && restrictedTrader){
				var message = String.format(L('Restricted_Trader_Txt'), ingrs.auth.clientInformationLine);
				ingrs.auth.ui.createRedirectLoginDialog({message:message,invokeFn:ingrs.auth.loginLogout}).show();
			}else{
				//check whether should be forced for edelivery notification
				if(isShowENotification(_response)){
					ingrs.log.debug('login() ::opening Edelivery notification:'+ingrs.auth.cssessionid);
					ingrs.auth.createEnhancedLoginWindow({status:'edelivery',response:_response}).open();
				}else{
					ingrs.log.debug('login() ::opening accntSummary window:'+ingrs.auth.cssessionid);
					ingrs.auth.createAcntSummaryWin(_response).open();
				}
			}
		}
	};
	
	//check whether Edelivery notification should be shown
	function isShowENotification(_param){
		if(_param.edeliveryFlag){
			//check whether the user already see this message on this device.
			try {
				var storedPref = Ti.App.Properties.getString('EDELIVERY_NOTIFICATION');
				ingrs.log.debug('login() :EDELIVERY_NOTIFICATION :'+storedPref);
				if (storedPref === 'true') {
					return false;
				}else{
					return true;
				}
			}catch(e) {
				Ti.API.error('EDELIVERY_NOTIFICATION removed - ' + e);
				Ti.App.Properties.removeProperty('EDELIVERY_NOTIFICATION');
			}
			
		}else{
			return false;
		}
	}
	
	ingrs.auth.endUserSession = function() {
		
	};
	
	ingrs.auth.pingUserSession = function() {
		
	};
	
	//listener called by all forced page after confirmation
	ingrs.auth.continueForceCheck =  function(_param){
		
		var forcePage = _param.forcePage;
		ingrs.log.debug('login() ::continueForceCheck event Fired for :'+ingrs.auth.cssessionid + ' | data :'+ forcePage);
	
		var url;
		if(forcePage === 'mfa_enrollment'){
			url = '/eportal/mobile/checkLoginPreference.action';
		}else if(forcePage === 'set_username'){
			url = '/eportal/mobile/checkSSOSecQues.action';
		}else if(forcePage === 'reset_username'){
			url = '/eportal/mobile/checkChangePin.action';
		}else if(forcePage === 'change_password'){
			url = '/eportal/mobile/checkUserLoginPref.action';
		}else if(forcePage === 'sso_security'){
			url = '/eportal/mobile/home.action';
		}
		
	};
	
})();
